'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

exports.localeLayout = localeLayout;

var _propTypes = require('prop-types');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//中转作用
var __r2Locale__;
/**
 * 使用redux切换语言
 *@param { array } 需要切换的语言列表
 */
function switchLanguage(switchedLocale) {
  if (!this.props.dispatch) {
    console.error('You must use redux connect for the layout component!');
    return;
  }
  this.props.dispatch({
    type: '@@locale/CHANGE',
    locale: switchedLocale
  });
}

/**
 * locale翻译替换函数，根据当前str和配置的语言选项替换。
 * @param {string} str 需要被替换的文字
 */
function t(str) {
  if (!this.props.defaultLocale) {
    console.error('You must use defaultlocale of store for redux connect!');
    return;
  }
  if (!__r2Locale__) {
    __r2Locale__ = {};
    this.props.defaultLocale.forEach(function (v, k) {
      __r2Locale__[v] = k;
    });
  }
  if (this.props.changedLocale) {
    var o = this.props.changedLocale[__r2Locale__[str]];
    if (o) {
      return o;
    }
  }
  return str;
}
/*
 * common view locale 装饰器
 */
function localeDecorator(component) {
  component.prototype.t = t;
  component.prototype.switchLanguage = switchLanguage;
  return component;
}
/*
 * laytou view locale 装饰器
 * @param { string } localePath 国际化文件夹路径，相对于src目录（例如locale传进去就相当于src/locale）
 *                              默认值为locale
 * @this changeLanguage layoutView提供的切换语言Event
 */
function localeLayout() {
  var localePath = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'locale';

  return function (component) {
    component.prototype.t = t;
    component.prototype.switchLanguage = switchLanguage;

    var ViewComponent = function (_component) {
      _inherits(ViewComponent, _component);

      function ViewComponent() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, ViewComponent);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ViewComponent.__proto__ || Object.getPrototypeOf(ViewComponent)).call.apply(_ref, [this].concat(args))), _this), _this.state = {}, _temp), _possibleConstructorReturn(_this, _ret);
      }

      _createClass(ViewComponent, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          _get(ViewComponent.prototype.__proto__ || Object.getPrototypeOf(ViewComponent.prototype), 'componentDidMount', this) && _get(ViewComponent.prototype.__proto__ || Object.getPrototypeOf(ViewComponent.prototype), 'componentDidMount', this).call(this);
          //使用记住的语言列表
          if (localStorage.currentLanguage) {
            this.changeLanguage(localStorage.currentLanguage)();
          }
        }
        /**
         * 语言切换，要设置好locale目录
         * @param { string } language 语言，按照文件命名来处理如zh_CN（.js）、en_US（.js）,.js可选
         * @param { function } beforCallback 语言切换前回调函数，可以用于展示加载状态
         * @param { function } afterCallback 语言切换成功回调函数，可以用于关闭展示加载状态
         */

      }, {
        key: 'changeLanguage',
        value: function changeLanguage(language, beforCallback, afterCallback) {
          var _this2 = this;

          return function (e) {
            beforCallback && beforCallback();
            //语言切换后，使用localStorage记住，网页重新载入时选择记住的语言
            localStorage.currentLanguage = language;
            var path = localePath + '/' + language;
            import('src/' + path).then(function (locale) {
              _this2.switchLanguage(locale.default);
              _this2.setState({
                canRender: true
              });
              afterCallback && afterCallback();
            });
          };
        }
      }, {
        key: 'render',
        value: function render() {
          //等待语言列表载入后才渲染
          if (localStorage.currentLanguage && !this.state.canRender) {
            return false;
          }
          return _get(ViewComponent.prototype.__proto__ || Object.getPrototypeOf(ViewComponent.prototype), 'render', this).call(this);
        }
      }]);

      return ViewComponent;
    }(component);

    ViewComponent.displayName = component.displayName || component.name;

    return ViewComponent;
  };
}

exports.default = localeDecorator;