'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = configureStore;

var _redux = require('redux');

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

var _reactRouterRedux = require('react-router-redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function configureStore(initialState, browserHistory, rootReducer) {
  if (process.env.useImmutable) {
    var Immutable = require('immutable');
    var combineReducers = require('redux-immutable').combineReducers;
    initialState = Immutable.fromJS({});
    var routing = function routing(state, action) {
      if (!state) {
        state = initialState;
      }
      if (action.type === _reactRouterRedux.LOCATION_CHANGE) {
        return state.merge({
          locationBeforeTransitions: action.payload
        });
      }
      return state;
    };
  } else {
    var combineReducers = require('redux').combineReducers;
    var routing = _reactRouterRedux.routerReducer;
  }
  var middleware = [_reduxThunk2.default];
  //下面这句话，必须设置，要不push没用
  var router = (0, _reactRouterRedux.routerMiddleware)(browserHistory);
  if (process.env.NODE_ENV == 'development') {
    var createLogger = require('redux-logger');
    middleware.push(router, createLogger());
  } else {
    middleware.push(router);
  }
  var finalCreateStore = _redux.applyMiddleware.apply(undefined, middleware)(_redux.createStore);
  var reducers = Object.assign({}, rootReducer, {
    routing: routing
  });
  var store = finalCreateStore(combineReducers(reducers), initialState);
  return store;
}